﻿using System;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WebForms;

namespace _9348
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                // Set the Map Unit. The reason for setting it to DecimalDegrees is that is what the shapefile’s unit of measure is inherently in.
                Map1.MapUnit = GeographyUnit.DecimalDegree;


                LayerOverlay layerOverlay = new LayerOverlay();
                ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(MapPath(@"App_Data\states.shp"));
                shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Military();
                shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                layerOverlay.Layers.Add(shapeFileLayer);
                Map1.CustomOverlays.Add(layerOverlay);

                //Proj4Projection _proj = new Proj4Projection(4326, 3857);

                NativeImageRasterLayer rasterRadar = new NativeImageRasterLayer(MapPath(@"App_Data\1.bmp"), new RectangleShape(-178.215027, 71.406647, -66.969849, 18.924782));//, _proj.ConvertToExternalProjection(new RectangleShape(-179.999979224, 85, 179.972976801, -85)));
                rasterRadar.Name = "RainViewer";

                //rasterRadar.WrappingExtent = _proj.ConvertToExternalProjection(new RectangleShape(-180, 90, 180, -90));
                layerOverlay.Layers.Add("", rasterRadar);


                LineStyle customDashLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.FromArgb(255, 255, 255, 255), 1, LineDashStyle.Custom, true);
                customDashLineStyle.CenterPen.DashPattern.Add(4f);
                customDashLineStyle.CenterPen.DashPattern.Add(4f);
                customDashLineStyle.CenterPen.DashPattern.Add(4f);
                customDashLineStyle.CenterPen.DashPattern.Add(4f);
                //GraticuleFeatureLayer graticuleAdornmentLayer = new GraticuleFeatureLayer(_proj);
                GraticuleFeatureLayer graticuleAdornmentLayer = new GraticuleFeatureLayer();
                //graticuleAdornmentLayer.WrappingMode = WrappingMode.WrapDateline;
                //graticuleAdornmentLayer.WrappingExtent = _proj.ConvertToExternalProjection(new RectangleShape(-180, 90, 180, -90));
                graticuleAdornmentLayer.GraticuleLineStyle = customDashLineStyle;
                LayerOverlay graticuleAdornmentLayerOverlay = new LayerOverlay();
                graticuleAdornmentLayerOverlay.TileType = TileType.SingleTile;
                graticuleAdornmentLayerOverlay.Layers.Add("GraticuleAdornmentLayer", graticuleAdornmentLayer);
                Map1.CustomOverlays.Add(graticuleAdornmentLayerOverlay);

                shapeFileLayer.Open();
                Map1.CurrentExtent = shapeFileLayer.GetBoundingBox();
            }
        }
    }
}